public static final class HttpRule.Builder extends com.google.protobuf.GeneratedMessage.Builder<HttpRule.Builder> implements HttpRuleOrBuilder
`HttpRule` defines the mapping of an RPC method to one or more HTTP
REST APIs. The mapping determines what portions of the request
message are populated from the path, query parameters, or body of
the HTTP request. The mapping is typically specified as an
`google.api.http` annotation, see "google/api/annotations.proto"
for details.
The mapping consists of a field specifying the path template and
method kind. The path template can refer to fields in the request
message, as in the example below which describes a REST GET
operation on a resource collection of messages:
service Messaging {
rpc GetMessage(GetMessageRequest) returns (Message) {
option (google.api.http).get = "/v1/messages/{message_id}/{sub.subfield}";
}
}
message GetMessageRequest {
message SubMessage {
string subfield = 1;
}
string message_id = 1; // mapped to the URL
SubMessage sub = 2; // `sub.subfield` is url-mapped
}
message Message {
string text = 1; // content of the resource
}
The same http annotation can alternatively be expressed inside the
`GRPC API Configuration` YAML file.
http:
rules:
- selector: <proto_package_name>.Messaging.GetMessage
get: /v1/messages/{message_id}/{sub.subfield}
This definition enables an automatic, bidrectional mapping of HTTP
JSON to RPC. Example:
HTTP | RPC
-----|-----
`GET /v1/messages/123456/foo` | `GetMessage(message_id: "123456" sub: SubMessage(subfield: "foo"))`
In general, not only fields but also field paths can be referenced
from a path pattern. Fields mapped to the path pattern cannot be
repeated and must have a primitive (non-message) type.
Any fields in the request message which are not bound by the path
pattern automatically become (optional) HTTP query
parameters. Assume the following definition of the request message:
message GetMessageRequest {
message SubMessage {
string subfield = 1;
}
string message_id = 1; // mapped to the URL
int64 revision = 2; // becomes a parameter
SubMessage sub = 3; // `sub.subfield` becomes a parameter
}
This enables a HTTP JSON to RPC mapping as below:
HTTP | RPC
-----|-----
`GET /v1/messages/123456?revision=2&sub.subfield=foo` | `GetMessage(message_id: "123456" revision: 2 sub: SubMessage(subfield: "foo"))`
Note that fields which are mapped to HTTP parameters must have a
primitive type or a repeated primitive type. Message types are not
allowed. In the case of a repeated type, the parameter can be
repeated in the URL, as in `...?param=A¶m=B`.
For HTTP method kinds which allow a request body, the `body` field
specifies the mapping. Consider a REST update method on the
message resource collection:
service Messaging {
rpc UpdateMessage(UpdateMessageRequest) returns (Message) {
option (google.api.http) = {
put: "/v1/messages/{message_id}"
body: "message"
};
}
}
message UpdateMessageRequest {
string message_id = 1; // mapped to the URL
Message message = 2; // mapped to the body
}
The following HTTP JSON to RPC mapping is enabled, where the
representation of the JSON in the request body is determined by
protos JSON encoding:
HTTP | RPC
-----|-----
`PUT /v1/messages/123456 { "text": "Hi!" }` | `UpdateMessage(message_id: "123456" message { text: "Hi!" })`
The special name `*` can be used in the body mapping to define that
every field not bound by the path template should be mapped to the
request body. This enables the following alternative definition of
the update method:
service Messaging {
rpc UpdateMessage(Message) returns (Message) {
option (google.api.http) = {
put: "/v1/messages/{message_id}"
body: "*"
};
}
}
message Message {
string message_id = 1;
string text = 2;
}
The following HTTP JSON to RPC mapping is enabled:
HTTP | RPC
-----|-----
`PUT /v1/messages/123456 { "text": "Hi!" }` | `UpdateMessage(message_id: "123456" text: "Hi!")`
Note that when using `*` in the body mapping, it is not possible to
have HTTP parameters, as all fields not bound by the path end in
the body. This makes this option more rarely used in practice of
defining REST APIs. The common usage of `*` is in custom methods
which don't use the URL at all for transferring data.
It is possible to define multiple HTTP methods for one RPC by using
the `additional_bindings` option. Example:
service Messaging {
rpc GetMessage(GetMessageRequest) returns (Message) {
option (google.api.http) = {
get: "/v1/messages/{message_id}"
additional_bindings {
get: "/v1/users/{user_id}/messages/{message_id}"
}
};
}
}
message GetMessageRequest {
string message_id = 1;
string user_id = 2;
}
This enables the following two alternative HTTP JSON to RPC
mappings:
HTTP | RPC
-----|-----
`GET /v1/messages/123456` | `GetMessage(message_id: "123456")`
`GET /v1/users/me/messages/123456` | `GetMessage(user_id: "me" message_id: "123456")`
# Rules for HTTP mapping
The rules for mapping HTTP path, query parameters, and body fields
to the request message are as follows:
1. The `body` field specifies either `*` or a field path, or is
omitted. If omitted, it assumes there is no HTTP body.
2. Leaf fields (recursive expansion of nested messages in the
request) can be classified into three types:
(a) Matched in the URL template.
(b) Covered by body (if body is `*`, everything except (a) fields;
else everything under the body field)
(c) All other fields.
3. URL query parameters found in the HTTP request are mapped to (c) fields.
4. Any body sent with an HTTP request can contain only (b) fields.
The syntax of the path template is as follows:
Template = "/" Segments [ Verb ] ;
Segments = Segment { "/" Segment } ;
Segment = "*" | "**" | LITERAL | Variable ;
Variable = "{" FieldPath [ "=" Segments ] "}" ;
FieldPath = IDENT { "." IDENT } ;
Verb = ":" LITERAL ;
The syntax `*` matches a single path segment. It follows the semantics of
[RFC 6570](https://tools.ietf.org/html/rfc6570) Section 3.2.2 Simple String
Expansion.
The syntax `**` matches zero or more path segments. It follows the semantics
of [RFC 6570](https://tools.ietf.org/html/rfc6570) Section 3.2.3 Reserved
Expansion. NOTE: it must be the last segment in the path except the Verb.
The syntax `LITERAL` matches literal text in the URL path.
The syntax `Variable` matches the entire path as specified by its template;
this nested template must not contain further variables. If a variable
matches a single path segment, its template may be omitted, e.g. `{var}`
is equivalent to `{var=*}`.
NOTE: the field paths in variables and in the `body` must not refer to
repeated fields or map fields.
Use CustomHttpPattern to specify any HTTP method that is not included in the
`pattern` field, such as HEAD, or "*" to leave the HTTP method unspecified for
a given URL path rule. The wild-card rule is useful for services that provide
content to Web (HTML) clients.
Protobuf type google.api.HttpRule| Modifier and Type | Method and Description |
|---|---|
HttpRule.Builder |
addAdditionalBindings(HttpRule.Builder builderForValue)
Additional HTTP bindings for the selector.
|
HttpRule.Builder |
addAdditionalBindings(HttpRule value)
Additional HTTP bindings for the selector.
|
HttpRule.Builder |
addAdditionalBindings(int index,
HttpRule.Builder builderForValue)
Additional HTTP bindings for the selector.
|
HttpRule.Builder |
addAdditionalBindings(int index,
HttpRule value)
Additional HTTP bindings for the selector.
|
HttpRule.Builder |
addAdditionalBindingsBuilder()
Additional HTTP bindings for the selector.
|
HttpRule.Builder |
addAdditionalBindingsBuilder(int index)
Additional HTTP bindings for the selector.
|
HttpRule.Builder |
addAllAdditionalBindings(java.lang.Iterable<? extends HttpRule> values)
Additional HTTP bindings for the selector.
|
HttpRule.Builder |
addRepeatedField(com.google.protobuf.Descriptors.FieldDescriptor field,
java.lang.Object value) |
HttpRule |
build() |
HttpRule |
buildPartial() |
HttpRule.Builder |
clear() |
HttpRule.Builder |
clearAdditionalBindings()
Additional HTTP bindings for the selector.
|
HttpRule.Builder |
clearBody()
The name of the request field whose value is mapped to the HTTP body, or
`*` for mapping all fields not captured by the path pattern to the HTTP
body.
|
HttpRule.Builder |
clearCustom()
Custom pattern is used for defining custom verbs.
|
HttpRule.Builder |
clearDelete()
Used for deleting a resource.
|
HttpRule.Builder |
clearField(com.google.protobuf.Descriptors.FieldDescriptor field) |
HttpRule.Builder |
clearGet()
Used for listing and getting information about resources.
|
HttpRule.Builder |
clearOneof(com.google.protobuf.Descriptors.OneofDescriptor oneof) |
HttpRule.Builder |
clearPatch()
Used for updating a resource.
|
HttpRule.Builder |
clearPattern() |
HttpRule.Builder |
clearPost()
Used for creating a resource.
|
HttpRule.Builder |
clearPut()
Used for updating a resource.
|
HttpRule.Builder |
clearSelector()
Selects methods to which this rule applies.
|
HttpRule.Builder |
clone() |
HttpRule |
getAdditionalBindings(int index)
Additional HTTP bindings for the selector.
|
HttpRule.Builder |
getAdditionalBindingsBuilder(int index)
Additional HTTP bindings for the selector.
|
java.util.List<HttpRule.Builder> |
getAdditionalBindingsBuilderList()
Additional HTTP bindings for the selector.
|
int |
getAdditionalBindingsCount()
Additional HTTP bindings for the selector.
|
java.util.List<HttpRule> |
getAdditionalBindingsList()
Additional HTTP bindings for the selector.
|
HttpRuleOrBuilder |
getAdditionalBindingsOrBuilder(int index)
Additional HTTP bindings for the selector.
|
java.util.List<? extends HttpRuleOrBuilder> |
getAdditionalBindingsOrBuilderList()
Additional HTTP bindings for the selector.
|
java.lang.String |
getBody()
The name of the request field whose value is mapped to the HTTP body, or
`*` for mapping all fields not captured by the path pattern to the HTTP
body.
|
com.google.protobuf.ByteString |
getBodyBytes()
The name of the request field whose value is mapped to the HTTP body, or
`*` for mapping all fields not captured by the path pattern to the HTTP
body.
|
CustomHttpPattern |
getCustom()
Custom pattern is used for defining custom verbs.
|
CustomHttpPattern.Builder |
getCustomBuilder()
Custom pattern is used for defining custom verbs.
|
CustomHttpPatternOrBuilder |
getCustomOrBuilder()
Custom pattern is used for defining custom verbs.
|
HttpRule |
getDefaultInstanceForType() |
java.lang.String |
getDelete()
Used for deleting a resource.
|
com.google.protobuf.ByteString |
getDeleteBytes()
Used for deleting a resource.
|
static com.google.protobuf.Descriptors.Descriptor |
getDescriptor() |
com.google.protobuf.Descriptors.Descriptor |
getDescriptorForType() |
java.lang.String |
getGet()
Used for listing and getting information about resources.
|
com.google.protobuf.ByteString |
getGetBytes()
Used for listing and getting information about resources.
|
java.lang.String |
getPatch()
Used for updating a resource.
|
com.google.protobuf.ByteString |
getPatchBytes()
Used for updating a resource.
|
HttpRule.PatternCase |
getPatternCase() |
java.lang.String |
getPost()
Used for creating a resource.
|
com.google.protobuf.ByteString |
getPostBytes()
Used for creating a resource.
|
java.lang.String |
getPut()
Used for updating a resource.
|
com.google.protobuf.ByteString |
getPutBytes()
Used for updating a resource.
|
java.lang.String |
getSelector()
Selects methods to which this rule applies.
|
com.google.protobuf.ByteString |
getSelectorBytes()
Selects methods to which this rule applies.
|
protected com.google.protobuf.GeneratedMessage.FieldAccessorTable |
internalGetFieldAccessorTable() |
boolean |
isInitialized() |
HttpRule.Builder |
mergeCustom(CustomHttpPattern value)
Custom pattern is used for defining custom verbs.
|
HttpRule.Builder |
mergeFrom(com.google.protobuf.CodedInputStream input,
com.google.protobuf.ExtensionRegistryLite extensionRegistry) |
HttpRule.Builder |
mergeFrom(HttpRule other) |
HttpRule.Builder |
mergeFrom(com.google.protobuf.Message other) |
HttpRule.Builder |
mergeUnknownFields(com.google.protobuf.UnknownFieldSet unknownFields) |
HttpRule.Builder |
removeAdditionalBindings(int index)
Additional HTTP bindings for the selector.
|
HttpRule.Builder |
setAdditionalBindings(int index,
HttpRule.Builder builderForValue)
Additional HTTP bindings for the selector.
|
HttpRule.Builder |
setAdditionalBindings(int index,
HttpRule value)
Additional HTTP bindings for the selector.
|
HttpRule.Builder |
setBody(java.lang.String value)
The name of the request field whose value is mapped to the HTTP body, or
`*` for mapping all fields not captured by the path pattern to the HTTP
body.
|
HttpRule.Builder |
setBodyBytes(com.google.protobuf.ByteString value)
The name of the request field whose value is mapped to the HTTP body, or
`*` for mapping all fields not captured by the path pattern to the HTTP
body.
|
HttpRule.Builder |
setCustom(CustomHttpPattern.Builder builderForValue)
Custom pattern is used for defining custom verbs.
|
HttpRule.Builder |
setCustom(CustomHttpPattern value)
Custom pattern is used for defining custom verbs.
|
HttpRule.Builder |
setDelete(java.lang.String value)
Used for deleting a resource.
|
HttpRule.Builder |
setDeleteBytes(com.google.protobuf.ByteString value)
Used for deleting a resource.
|
HttpRule.Builder |
setField(com.google.protobuf.Descriptors.FieldDescriptor field,
java.lang.Object value) |
HttpRule.Builder |
setGet(java.lang.String value)
Used for listing and getting information about resources.
|
HttpRule.Builder |
setGetBytes(com.google.protobuf.ByteString value)
Used for listing and getting information about resources.
|
HttpRule.Builder |
setPatch(java.lang.String value)
Used for updating a resource.
|
HttpRule.Builder |
setPatchBytes(com.google.protobuf.ByteString value)
Used for updating a resource.
|
HttpRule.Builder |
setPost(java.lang.String value)
Used for creating a resource.
|
HttpRule.Builder |
setPostBytes(com.google.protobuf.ByteString value)
Used for creating a resource.
|
HttpRule.Builder |
setPut(java.lang.String value)
Used for updating a resource.
|
HttpRule.Builder |
setPutBytes(com.google.protobuf.ByteString value)
Used for updating a resource.
|
HttpRule.Builder |
setRepeatedField(com.google.protobuf.Descriptors.FieldDescriptor field,
int index,
java.lang.Object value) |
HttpRule.Builder |
setSelector(java.lang.String value)
Selects methods to which this rule applies.
|
HttpRule.Builder |
setSelectorBytes(com.google.protobuf.ByteString value)
Selects methods to which this rule applies.
|
HttpRule.Builder |
setUnknownFields(com.google.protobuf.UnknownFieldSet unknownFields) |
getAllFields, getField, getFieldBuilder, getOneofFieldDescriptor, getParentForChildren, getRepeatedField, getRepeatedFieldBuilder, getRepeatedFieldCount, getUnknownFields, hasField, hasOneof, internalGetMapField, internalGetMutableMapField, isClean, markClean, newBuilderForField, onBuilt, onChanged, parseUnknownFieldfindInitializationErrors, getInitializationErrorString, internalMergeFrom, mergeDelimitedFrom, mergeDelimitedFrom, mergeFrom, mergeFrom, mergeFrom, mergeFrom, mergeFrom, mergeFrom, mergeFrom, mergeFrom, mergeFrom, newUninitializedMessageException, toStringaddAll, mergeFrom, newUninitializedMessageExceptionequals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, waitpublic static final com.google.protobuf.Descriptors.Descriptor getDescriptor()
protected com.google.protobuf.GeneratedMessage.FieldAccessorTable internalGetFieldAccessorTable()
internalGetFieldAccessorTable in class com.google.protobuf.GeneratedMessage.Builder<HttpRule.Builder>public HttpRule.Builder clear()
clear in interface com.google.protobuf.Message.Builderclear in interface com.google.protobuf.MessageLite.Builderclear in class com.google.protobuf.GeneratedMessage.Builder<HttpRule.Builder>public com.google.protobuf.Descriptors.Descriptor getDescriptorForType()
getDescriptorForType in interface com.google.protobuf.Message.BuildergetDescriptorForType in interface com.google.protobuf.MessageOrBuildergetDescriptorForType in class com.google.protobuf.GeneratedMessage.Builder<HttpRule.Builder>public HttpRule getDefaultInstanceForType()
getDefaultInstanceForType in interface com.google.protobuf.MessageLiteOrBuildergetDefaultInstanceForType in interface com.google.protobuf.MessageOrBuilderpublic HttpRule build()
build in interface com.google.protobuf.Message.Builderbuild in interface com.google.protobuf.MessageLite.Builderpublic HttpRule buildPartial()
buildPartial in interface com.google.protobuf.Message.BuilderbuildPartial in interface com.google.protobuf.MessageLite.Builderpublic HttpRule.Builder clone()
clone in interface com.google.protobuf.Message.Builderclone in interface com.google.protobuf.MessageLite.Builderclone in class com.google.protobuf.GeneratedMessage.Builder<HttpRule.Builder>public HttpRule.Builder setField(com.google.protobuf.Descriptors.FieldDescriptor field, java.lang.Object value)
setField in interface com.google.protobuf.Message.BuildersetField in class com.google.protobuf.GeneratedMessage.Builder<HttpRule.Builder>public HttpRule.Builder clearField(com.google.protobuf.Descriptors.FieldDescriptor field)
clearField in interface com.google.protobuf.Message.BuilderclearField in class com.google.protobuf.GeneratedMessage.Builder<HttpRule.Builder>public HttpRule.Builder clearOneof(com.google.protobuf.Descriptors.OneofDescriptor oneof)
clearOneof in interface com.google.protobuf.Message.BuilderclearOneof in class com.google.protobuf.GeneratedMessage.Builder<HttpRule.Builder>public HttpRule.Builder setRepeatedField(com.google.protobuf.Descriptors.FieldDescriptor field, int index, java.lang.Object value)
setRepeatedField in interface com.google.protobuf.Message.BuildersetRepeatedField in class com.google.protobuf.GeneratedMessage.Builder<HttpRule.Builder>public HttpRule.Builder addRepeatedField(com.google.protobuf.Descriptors.FieldDescriptor field, java.lang.Object value)
addRepeatedField in interface com.google.protobuf.Message.BuilderaddRepeatedField in class com.google.protobuf.GeneratedMessage.Builder<HttpRule.Builder>public HttpRule.Builder mergeFrom(com.google.protobuf.Message other)
mergeFrom in interface com.google.protobuf.Message.BuildermergeFrom in class com.google.protobuf.AbstractMessage.Builder<HttpRule.Builder>public HttpRule.Builder mergeFrom(HttpRule other)
public final boolean isInitialized()
isInitialized in interface com.google.protobuf.MessageLiteOrBuilderisInitialized in class com.google.protobuf.GeneratedMessage.Builder<HttpRule.Builder>public HttpRule.Builder mergeFrom(com.google.protobuf.CodedInputStream input, com.google.protobuf.ExtensionRegistryLite extensionRegistry) throws java.io.IOException
mergeFrom in interface com.google.protobuf.Message.BuildermergeFrom in interface com.google.protobuf.MessageLite.BuildermergeFrom in class com.google.protobuf.AbstractMessage.Builder<HttpRule.Builder>java.io.IOExceptionpublic HttpRule.PatternCase getPatternCase()
getPatternCase in interface HttpRuleOrBuilderpublic HttpRule.Builder clearPattern()
public java.lang.String getSelector()
Selects methods to which this rule applies. Refer to [selector][google.api.DocumentationRule.selector] for syntax details.
optional string selector = 1;getSelector in interface HttpRuleOrBuilderpublic com.google.protobuf.ByteString getSelectorBytes()
Selects methods to which this rule applies. Refer to [selector][google.api.DocumentationRule.selector] for syntax details.
optional string selector = 1;getSelectorBytes in interface HttpRuleOrBuilderpublic HttpRule.Builder setSelector(java.lang.String value)
Selects methods to which this rule applies. Refer to [selector][google.api.DocumentationRule.selector] for syntax details.
optional string selector = 1;public HttpRule.Builder clearSelector()
Selects methods to which this rule applies. Refer to [selector][google.api.DocumentationRule.selector] for syntax details.
optional string selector = 1;public HttpRule.Builder setSelectorBytes(com.google.protobuf.ByteString value)
Selects methods to which this rule applies. Refer to [selector][google.api.DocumentationRule.selector] for syntax details.
optional string selector = 1;public java.lang.String getGet()
Used for listing and getting information about resources.
optional string get = 2;getGet in interface HttpRuleOrBuilderpublic com.google.protobuf.ByteString getGetBytes()
Used for listing and getting information about resources.
optional string get = 2;getGetBytes in interface HttpRuleOrBuilderpublic HttpRule.Builder setGet(java.lang.String value)
Used for listing and getting information about resources.
optional string get = 2;public HttpRule.Builder clearGet()
Used for listing and getting information about resources.
optional string get = 2;public HttpRule.Builder setGetBytes(com.google.protobuf.ByteString value)
Used for listing and getting information about resources.
optional string get = 2;public java.lang.String getPut()
Used for updating a resource.
optional string put = 3;getPut in interface HttpRuleOrBuilderpublic com.google.protobuf.ByteString getPutBytes()
Used for updating a resource.
optional string put = 3;getPutBytes in interface HttpRuleOrBuilderpublic HttpRule.Builder setPut(java.lang.String value)
Used for updating a resource.
optional string put = 3;public HttpRule.Builder clearPut()
Used for updating a resource.
optional string put = 3;public HttpRule.Builder setPutBytes(com.google.protobuf.ByteString value)
Used for updating a resource.
optional string put = 3;public java.lang.String getPost()
Used for creating a resource.
optional string post = 4;getPost in interface HttpRuleOrBuilderpublic com.google.protobuf.ByteString getPostBytes()
Used for creating a resource.
optional string post = 4;getPostBytes in interface HttpRuleOrBuilderpublic HttpRule.Builder setPost(java.lang.String value)
Used for creating a resource.
optional string post = 4;public HttpRule.Builder clearPost()
Used for creating a resource.
optional string post = 4;public HttpRule.Builder setPostBytes(com.google.protobuf.ByteString value)
Used for creating a resource.
optional string post = 4;public java.lang.String getDelete()
Used for deleting a resource.
optional string delete = 5;getDelete in interface HttpRuleOrBuilderpublic com.google.protobuf.ByteString getDeleteBytes()
Used for deleting a resource.
optional string delete = 5;getDeleteBytes in interface HttpRuleOrBuilderpublic HttpRule.Builder setDelete(java.lang.String value)
Used for deleting a resource.
optional string delete = 5;public HttpRule.Builder clearDelete()
Used for deleting a resource.
optional string delete = 5;public HttpRule.Builder setDeleteBytes(com.google.protobuf.ByteString value)
Used for deleting a resource.
optional string delete = 5;public java.lang.String getPatch()
Used for updating a resource.
optional string patch = 6;getPatch in interface HttpRuleOrBuilderpublic com.google.protobuf.ByteString getPatchBytes()
Used for updating a resource.
optional string patch = 6;getPatchBytes in interface HttpRuleOrBuilderpublic HttpRule.Builder setPatch(java.lang.String value)
Used for updating a resource.
optional string patch = 6;public HttpRule.Builder clearPatch()
Used for updating a resource.
optional string patch = 6;public HttpRule.Builder setPatchBytes(com.google.protobuf.ByteString value)
Used for updating a resource.
optional string patch = 6;public CustomHttpPattern getCustom()
Custom pattern is used for defining custom verbs.
optional .google.api.CustomHttpPattern custom = 8;getCustom in interface HttpRuleOrBuilderpublic HttpRule.Builder setCustom(CustomHttpPattern value)
Custom pattern is used for defining custom verbs.
optional .google.api.CustomHttpPattern custom = 8;public HttpRule.Builder setCustom(CustomHttpPattern.Builder builderForValue)
Custom pattern is used for defining custom verbs.
optional .google.api.CustomHttpPattern custom = 8;public HttpRule.Builder mergeCustom(CustomHttpPattern value)
Custom pattern is used for defining custom verbs.
optional .google.api.CustomHttpPattern custom = 8;public HttpRule.Builder clearCustom()
Custom pattern is used for defining custom verbs.
optional .google.api.CustomHttpPattern custom = 8;public CustomHttpPattern.Builder getCustomBuilder()
Custom pattern is used for defining custom verbs.
optional .google.api.CustomHttpPattern custom = 8;public CustomHttpPatternOrBuilder getCustomOrBuilder()
Custom pattern is used for defining custom verbs.
optional .google.api.CustomHttpPattern custom = 8;getCustomOrBuilder in interface HttpRuleOrBuilderpublic java.lang.String getBody()
The name of the request field whose value is mapped to the HTTP body, or `*` for mapping all fields not captured by the path pattern to the HTTP body. NOTE: the referred field must not be a repeated field and must be present at the top-level of request message type.
optional string body = 7;getBody in interface HttpRuleOrBuilderpublic com.google.protobuf.ByteString getBodyBytes()
The name of the request field whose value is mapped to the HTTP body, or `*` for mapping all fields not captured by the path pattern to the HTTP body. NOTE: the referred field must not be a repeated field and must be present at the top-level of request message type.
optional string body = 7;getBodyBytes in interface HttpRuleOrBuilderpublic HttpRule.Builder setBody(java.lang.String value)
The name of the request field whose value is mapped to the HTTP body, or `*` for mapping all fields not captured by the path pattern to the HTTP body. NOTE: the referred field must not be a repeated field and must be present at the top-level of request message type.
optional string body = 7;public HttpRule.Builder clearBody()
The name of the request field whose value is mapped to the HTTP body, or `*` for mapping all fields not captured by the path pattern to the HTTP body. NOTE: the referred field must not be a repeated field and must be present at the top-level of request message type.
optional string body = 7;public HttpRule.Builder setBodyBytes(com.google.protobuf.ByteString value)
The name of the request field whose value is mapped to the HTTP body, or `*` for mapping all fields not captured by the path pattern to the HTTP body. NOTE: the referred field must not be a repeated field and must be present at the top-level of request message type.
optional string body = 7;public java.util.List<HttpRule> getAdditionalBindingsList()
Additional HTTP bindings for the selector. Nested bindings must not contain an `additional_bindings` field themselves (that is, the nesting may only be one level deep).
repeated .google.api.HttpRule additional_bindings = 11;getAdditionalBindingsList in interface HttpRuleOrBuilderpublic int getAdditionalBindingsCount()
Additional HTTP bindings for the selector. Nested bindings must not contain an `additional_bindings` field themselves (that is, the nesting may only be one level deep).
repeated .google.api.HttpRule additional_bindings = 11;getAdditionalBindingsCount in interface HttpRuleOrBuilderpublic HttpRule getAdditionalBindings(int index)
Additional HTTP bindings for the selector. Nested bindings must not contain an `additional_bindings` field themselves (that is, the nesting may only be one level deep).
repeated .google.api.HttpRule additional_bindings = 11;getAdditionalBindings in interface HttpRuleOrBuilderpublic HttpRule.Builder setAdditionalBindings(int index, HttpRule value)
Additional HTTP bindings for the selector. Nested bindings must not contain an `additional_bindings` field themselves (that is, the nesting may only be one level deep).
repeated .google.api.HttpRule additional_bindings = 11;public HttpRule.Builder setAdditionalBindings(int index, HttpRule.Builder builderForValue)
Additional HTTP bindings for the selector. Nested bindings must not contain an `additional_bindings` field themselves (that is, the nesting may only be one level deep).
repeated .google.api.HttpRule additional_bindings = 11;public HttpRule.Builder addAdditionalBindings(HttpRule value)
Additional HTTP bindings for the selector. Nested bindings must not contain an `additional_bindings` field themselves (that is, the nesting may only be one level deep).
repeated .google.api.HttpRule additional_bindings = 11;public HttpRule.Builder addAdditionalBindings(int index, HttpRule value)
Additional HTTP bindings for the selector. Nested bindings must not contain an `additional_bindings` field themselves (that is, the nesting may only be one level deep).
repeated .google.api.HttpRule additional_bindings = 11;public HttpRule.Builder addAdditionalBindings(HttpRule.Builder builderForValue)
Additional HTTP bindings for the selector. Nested bindings must not contain an `additional_bindings` field themselves (that is, the nesting may only be one level deep).
repeated .google.api.HttpRule additional_bindings = 11;public HttpRule.Builder addAdditionalBindings(int index, HttpRule.Builder builderForValue)
Additional HTTP bindings for the selector. Nested bindings must not contain an `additional_bindings` field themselves (that is, the nesting may only be one level deep).
repeated .google.api.HttpRule additional_bindings = 11;public HttpRule.Builder addAllAdditionalBindings(java.lang.Iterable<? extends HttpRule> values)
Additional HTTP bindings for the selector. Nested bindings must not contain an `additional_bindings` field themselves (that is, the nesting may only be one level deep).
repeated .google.api.HttpRule additional_bindings = 11;public HttpRule.Builder clearAdditionalBindings()
Additional HTTP bindings for the selector. Nested bindings must not contain an `additional_bindings` field themselves (that is, the nesting may only be one level deep).
repeated .google.api.HttpRule additional_bindings = 11;public HttpRule.Builder removeAdditionalBindings(int index)
Additional HTTP bindings for the selector. Nested bindings must not contain an `additional_bindings` field themselves (that is, the nesting may only be one level deep).
repeated .google.api.HttpRule additional_bindings = 11;public HttpRule.Builder getAdditionalBindingsBuilder(int index)
Additional HTTP bindings for the selector. Nested bindings must not contain an `additional_bindings` field themselves (that is, the nesting may only be one level deep).
repeated .google.api.HttpRule additional_bindings = 11;public HttpRuleOrBuilder getAdditionalBindingsOrBuilder(int index)
Additional HTTP bindings for the selector. Nested bindings must not contain an `additional_bindings` field themselves (that is, the nesting may only be one level deep).
repeated .google.api.HttpRule additional_bindings = 11;getAdditionalBindingsOrBuilder in interface HttpRuleOrBuilderpublic java.util.List<? extends HttpRuleOrBuilder> getAdditionalBindingsOrBuilderList()
Additional HTTP bindings for the selector. Nested bindings must not contain an `additional_bindings` field themselves (that is, the nesting may only be one level deep).
repeated .google.api.HttpRule additional_bindings = 11;getAdditionalBindingsOrBuilderList in interface HttpRuleOrBuilderpublic HttpRule.Builder addAdditionalBindingsBuilder()
Additional HTTP bindings for the selector. Nested bindings must not contain an `additional_bindings` field themselves (that is, the nesting may only be one level deep).
repeated .google.api.HttpRule additional_bindings = 11;public HttpRule.Builder addAdditionalBindingsBuilder(int index)
Additional HTTP bindings for the selector. Nested bindings must not contain an `additional_bindings` field themselves (that is, the nesting may only be one level deep).
repeated .google.api.HttpRule additional_bindings = 11;public java.util.List<HttpRule.Builder> getAdditionalBindingsBuilderList()
Additional HTTP bindings for the selector. Nested bindings must not contain an `additional_bindings` field themselves (that is, the nesting may only be one level deep).
repeated .google.api.HttpRule additional_bindings = 11;public final HttpRule.Builder setUnknownFields(com.google.protobuf.UnknownFieldSet unknownFields)
setUnknownFields in interface com.google.protobuf.Message.BuildersetUnknownFields in class com.google.protobuf.GeneratedMessage.Builder<HttpRule.Builder>public final HttpRule.Builder mergeUnknownFields(com.google.protobuf.UnknownFieldSet unknownFields)
mergeUnknownFields in interface com.google.protobuf.Message.BuildermergeUnknownFields in class com.google.protobuf.GeneratedMessage.Builder<HttpRule.Builder>